//////////////////////////////////////////////////////////////////////////////
//
// (C) Copyright Vicente J. Botet Escriba 2008. Distributed under the Boost
// Software License, Version 1.0. (See accompanying file
// LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
//
// See http://www.boost.org/libs/sync for documentation.
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __BOOST_SYNC_THREAD_RECURSIVE_MUTEX__HPP
#define __BOOST_SYNC_THREAD_RECURSIVE_MUTEX__HPP

#include <boost/thread/recursive_mutex.hpp>
#include <boost/sync/lockable_traits.hpp>

namespace boost { namespace sync {

typedef boost::recursive_mutex thread_recursive_mutex;

template<>
struct timed_interface_tag<boost::recursive_mutex> {
	typedef hasnt_timed_interface_tag type; 
};
template<>
struct reentrancy_tag<boost::recursive_mutex> {
	typedef recursive_tag type; 
};
template<>
struct category_tag<boost::recursive_mutex> {
	typedef exclusive_lock_tag type; 
};
template<>
struct scope_tag<boost::recursive_mutex> {
	typedef multi_threaded_tag type; 
};

typedef boost::recursive_timed_mutex thread_recursive_timed_mutex;

template<>
struct timed_interface_tag<boost::recursive_timed_mutex> {
	typedef has_timed_interface_tag type; 
};
template<>
struct reentrancy_tag<boost::recursive_timed_mutex> {
	typedef recursive_tag type; 
};
template<>
struct category_tag<boost::recursive_timed_mutex> {
	typedef exclusive_lock_tag type; 
};
template<>
struct scope_tag<boost::recursive_timed_mutex> {
	typedef multi_threaded_tag type; 
};


	
}
}

#endif
